/* LayoutUp.c generated by valac 0.56.12, the Vala compiler
 * generated from LayoutUp.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_LAYOUT (layout_get_type ())
#define LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LAYOUT, Layout))
#define LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LAYOUT, LayoutClass))
#define IS_LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LAYOUT))
#define IS_LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LAYOUT))
#define LAYOUT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LAYOUT, LayoutClass))

typedef struct _Layout Layout;
typedef struct _LayoutClass LayoutClass;
typedef struct _LayoutPrivate LayoutPrivate;
typedef enum  {
	NODE_SIDE_LEFT = 1,
	NODE_SIDE_TOP = 2,
	NODE_SIDE_RIGHT = 4,
	NODE_SIDE_BOTTOM = 8
} NodeSide;

#define TYPE_NODE_SIDE (node_side_get_type ())

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;

#define TYPE_NODE_BOUNDS (node_bounds_get_type ())
#define NODE_BOUNDS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE_BOUNDS, NodeBounds))
#define NODE_BOUNDS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE_BOUNDS, NodeBoundsClass))
#define IS_NODE_BOUNDS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE_BOUNDS))
#define IS_NODE_BOUNDS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE_BOUNDS))
#define NODE_BOUNDS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE_BOUNDS, NodeBoundsClass))

typedef struct _NodeBounds NodeBounds;
typedef struct _NodeBoundsClass NodeBoundsClass;

#define TYPE_LAYOUT_UP (layout_up_get_type ())
#define LAYOUT_UP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LAYOUT_UP, LayoutUp))
#define LAYOUT_UP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LAYOUT_UP, LayoutUpClass))
#define IS_LAYOUT_UP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LAYOUT_UP))
#define IS_LAYOUT_UP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LAYOUT_UP))
#define LAYOUT_UP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LAYOUT_UP, LayoutUpClass))

typedef struct _LayoutUp LayoutUp;
typedef struct _LayoutUpClass LayoutUpClass;
typedef struct _LayoutUpPrivate LayoutUpPrivate;
enum  {
	LAYOUT_UP_0_PROPERTY,
	LAYOUT_UP_NUM_PROPERTIES
};
static GParamSpec* layout_up_properties[LAYOUT_UP_NUM_PROPERTIES];

struct _Layout {
	GObject parent_instance;
	LayoutPrivate * priv;
	gdouble _rt_gap;
};

struct _LayoutClass {
	GObjectClass parent_class;
	NodeSide (*side_mapping) (Layout* self, NodeSide side);
	void (*initialize) (Layout* self, Node* parent);
	NodeBounds* (*bbox) (Layout* self, Node* parent, gint side_mask);
	void (*adjust_tree) (Layout* self, Node* parent, gint child_index, gint side_mask, gdouble amount);
	void (*adjust_tree_all) (Layout* self, Node* n, NodeBounds* p, gdouble amount, const gchar* msg);
	void (*propagate_side) (Layout* self, Node* parent, NodeSide side);
	NodeSide (*get_side) (Layout* self, Node* n);
	void (*set_side) (Layout* self, Node* current);
	void (*handle_update_by_edit) (Layout* self, Node* n, gdouble diffw, gdouble diffh);
	void (*handle_update_by_fold) (Layout* self, Node* n);
	gdouble (*get_insert_adjust) (Layout* self, Node* child);
	void (*handle_update_by_insert) (Layout* self, Node* parent, Node* child, gint pos);
	void (*handle_update_by_delete) (Layout* self, Node* parent, gint index, NodeSide side, gdouble size);
	void (*position_root) (Layout* self, Node* last, Node* n);
};

struct _LayoutUp {
	Layout parent_instance;
	LayoutUpPrivate * priv;
};

struct _LayoutUpClass {
	LayoutClass parent_class;
};

static gpointer layout_up_parent_class = NULL;

VALA_EXTERN GType layout_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Layout, g_object_unref)
VALA_EXTERN GType node_side_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType node_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Node, g_object_unref)
VALA_EXTERN gpointer node_bounds_ref (gpointer instance);
VALA_EXTERN void node_bounds_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_node_bounds (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags);
VALA_EXTERN void value_set_node_bounds (GValue* value,
                            gpointer v_object);
VALA_EXTERN void value_take_node_bounds (GValue* value,
                             gpointer v_object);
VALA_EXTERN gpointer value_get_node_bounds (const GValue* value);
VALA_EXTERN GType node_bounds_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NodeBounds, node_bounds_unref)
VALA_EXTERN GType layout_up_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LayoutUp, g_object_unref)
VALA_EXTERN NodeSide layout_side_mapping (Layout* self,
                              NodeSide side);
VALA_EXTERN void layout_set_side (Layout* self,
                      Node* current);
VALA_EXTERN LayoutUp* layout_up_new (void);
VALA_EXTERN LayoutUp* layout_up_construct (GType object_type);
VALA_EXTERN Layout* layout_new (void);
VALA_EXTERN Layout* layout_construct (GType object_type);
VALA_EXTERN void layout_set_name (Layout* self,
                      const gchar* value);
VALA_EXTERN void layout_set_icon (Layout* self,
                      const gchar* value);
VALA_EXTERN void layout_set_balanceable (Layout* self,
                             gboolean value);
static NodeSide layout_up_real_side_mapping (Layout* base,
                                      NodeSide side);
static void layout_up_real_set_side (Layout* base,
                              Node* current);
VALA_EXTERN void node_set_side (Node* self,
                    NodeSide value);
static GType layout_up_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

LayoutUp*
layout_up_construct (GType object_type)
{
	LayoutUp * self = NULL;
	self = (LayoutUp*) layout_construct (object_type);
	layout_set_name ((Layout*) self, _ ("Upwards"));
	layout_set_icon ((Layout*) self, "minder-layout-up-symbolic");
	layout_set_balanceable ((Layout*) self, FALSE);
	return self;
}

LayoutUp*
layout_up_new (void)
{
	return layout_up_construct (TYPE_LAYOUT_UP);
}

static NodeSide
layout_up_real_side_mapping (Layout* base,
                             NodeSide side)
{
	LayoutUp * self;
	NodeSide result;
	self = (LayoutUp*) base;
	result = NODE_SIDE_TOP;
	return result;
}

static void
layout_up_real_set_side (Layout* base,
                         Node* current)
{
	LayoutUp * self;
	self = (LayoutUp*) base;
	g_return_if_fail (current != NULL);
	node_set_side (current, NODE_SIDE_TOP);
}

static void
layout_up_class_init (LayoutUpClass * klass,
                      gpointer klass_data)
{
	layout_up_parent_class = g_type_class_peek_parent (klass);
	((LayoutClass *) klass)->side_mapping = (NodeSide (*) (Layout*, NodeSide)) layout_up_real_side_mapping;
	((LayoutClass *) klass)->set_side = (void (*) (Layout*, Node*)) layout_up_real_set_side;
}

static void
layout_up_instance_init (LayoutUp * self,
                         gpointer klass)
{
}

static GType
layout_up_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LayoutUpClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) layout_up_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LayoutUp), 0, (GInstanceInitFunc) layout_up_instance_init, NULL };
	GType layout_up_type_id;
	layout_up_type_id = g_type_register_static (TYPE_LAYOUT, "LayoutUp", &g_define_type_info, 0);
	return layout_up_type_id;
}

GType
layout_up_get_type (void)
{
	static volatile gsize layout_up_type_id__once = 0;
	if (g_once_init_enter (&layout_up_type_id__once)) {
		GType layout_up_type_id;
		layout_up_type_id = layout_up_get_type_once ();
		g_once_init_leave (&layout_up_type_id__once, layout_up_type_id);
	}
	return layout_up_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

