/* UndoConnectionColor.c generated by valac 0.56.12, the Vala compiler
 * generated from UndoConnectionColor.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_UNDO_ITEM (undo_item_get_type ())
#define UNDO_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UNDO_ITEM, UndoItem))
#define UNDO_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UNDO_ITEM, UndoItemClass))
#define IS_UNDO_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UNDO_ITEM))
#define IS_UNDO_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UNDO_ITEM))
#define UNDO_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UNDO_ITEM, UndoItemClass))

typedef struct _UndoItem UndoItem;
typedef struct _UndoItemClass UndoItemClass;
typedef struct _UndoItemPrivate UndoItemPrivate;

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;

#define TYPE_UNDO_CONNECTION_COLOR (undo_connection_color_get_type ())
#define UNDO_CONNECTION_COLOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UNDO_CONNECTION_COLOR, UndoConnectionColor))
#define UNDO_CONNECTION_COLOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UNDO_CONNECTION_COLOR, UndoConnectionColorClass))
#define IS_UNDO_CONNECTION_COLOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UNDO_CONNECTION_COLOR))
#define IS_UNDO_CONNECTION_COLOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UNDO_CONNECTION_COLOR))
#define UNDO_CONNECTION_COLOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UNDO_CONNECTION_COLOR, UndoConnectionColorClass))

typedef struct _UndoConnectionColor UndoConnectionColor;
typedef struct _UndoConnectionColorClass UndoConnectionColorClass;
typedef struct _UndoConnectionColorPrivate UndoConnectionColorPrivate;

#define TYPE_CONNECTION (connection_get_type ())
#define CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONNECTION, Connection))
#define CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONNECTION, ConnectionClass))
#define IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONNECTION))
#define IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONNECTION))
#define CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONNECTION, ConnectionClass))

typedef struct _Connection Connection;
typedef struct _ConnectionClass ConnectionClass;
enum  {
	UNDO_CONNECTION_COLOR_0_PROPERTY,
	UNDO_CONNECTION_COLOR_NUM_PROPERTIES
};
static GParamSpec* undo_connection_color_properties[UNDO_CONNECTION_COLOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_GdkRGBA_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkRGBA_free (var), NULL)))

struct _UndoItem {
	GObject parent_instance;
	UndoItemPrivate * priv;
};

struct _UndoItemClass {
	GObjectClass parent_class;
	void (*undo) (UndoItem* self, DrawArea* da);
	void (*redo) (UndoItem* self, DrawArea* da);
	gboolean (*matches) (UndoItem* self, UndoItem* item);
	void (*replace_with_item) (UndoItem* self, UndoItem* item);
	gchar* (*to_string) (UndoItem* self);
};

struct _UndoConnectionColor {
	UndoItem parent_instance;
	UndoConnectionColorPrivate * priv;
};

struct _UndoConnectionColorClass {
	UndoItemClass parent_class;
};

struct _UndoConnectionColorPrivate {
	Connection* _conn;
	GdkRGBA* _old_color;
	GdkRGBA* _new_color;
};

static gint UndoConnectionColor_private_offset;
static gpointer undo_connection_color_parent_class = NULL;

VALA_EXTERN GType undo_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UndoItem, g_object_unref)
VALA_EXTERN GType draw_area_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DrawArea, g_object_unref)
VALA_EXTERN GType undo_connection_color_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UndoConnectionColor, g_object_unref)
VALA_EXTERN GType connection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Connection, g_object_unref)
VALA_EXTERN void undo_item_undo (UndoItem* self,
                     DrawArea* da);
VALA_EXTERN void undo_item_redo (UndoItem* self,
                     DrawArea* da);
static void _vala_GdkRGBA_free (GdkRGBA* self);
VALA_EXTERN UndoConnectionColor* undo_connection_color_new (Connection* c,
                                                GdkRGBA* old_color);
VALA_EXTERN UndoConnectionColor* undo_connection_color_construct (GType object_type,
                                                      Connection* c,
                                                      GdkRGBA* old_color);
VALA_EXTERN UndoItem* undo_item_new (const gchar* name);
VALA_EXTERN UndoItem* undo_item_construct (GType object_type,
                               const gchar* name);
static GdkRGBA* _vala_GdkRGBA_copy (GdkRGBA* self);
VALA_EXTERN GdkRGBA* connection_get_color (Connection* self);
static void undo_connection_color_real_undo (UndoItem* base,
                                      DrawArea* da);
VALA_EXTERN void connection_set_color (Connection* self,
                           GdkRGBA* value);
VALA_EXTERN void draw_area_auto_save (DrawArea* self);
static void undo_connection_color_real_redo (UndoItem* base,
                                      DrawArea* da);
static void undo_connection_color_finalize (GObject * obj);
static GType undo_connection_color_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
undo_connection_color_get_instance_private (UndoConnectionColor* self)
{
	return G_STRUCT_MEMBER_P (self, UndoConnectionColor_private_offset);
}

static void
_vala_GdkRGBA_free (GdkRGBA* self)
{
	g_boxed_free (gdk_rgba_get_type (), self);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static GdkRGBA*
_vala_GdkRGBA_copy (GdkRGBA* self)
{
	return g_boxed_copy (gdk_rgba_get_type (), self);
}

static gpointer
__vala_GdkRGBA_copy0 (gpointer self)
{
	return self ? _vala_GdkRGBA_copy (self) : NULL;
}

UndoConnectionColor*
undo_connection_color_construct (GType object_type,
                                 Connection* c,
                                 GdkRGBA* old_color)
{
	UndoConnectionColor * self = NULL;
	Connection* _tmp0_;
	GdkRGBA* _tmp1_;
	GdkRGBA* _tmp2_;
	GdkRGBA* _tmp3_;
	GdkRGBA* _tmp4_;
	g_return_val_if_fail (c != NULL, NULL);
	self = (UndoConnectionColor*) undo_item_construct (object_type, _ ("connection color change"));
	_tmp0_ = _g_object_ref0 (c);
	_g_object_unref0 (self->priv->_conn);
	self->priv->_conn = _tmp0_;
	_tmp1_ = __vala_GdkRGBA_copy0 (old_color);
	__vala_GdkRGBA_free0 (self->priv->_old_color);
	self->priv->_old_color = _tmp1_;
	_tmp2_ = connection_get_color (c);
	_tmp3_ = _tmp2_;
	_tmp4_ = __vala_GdkRGBA_copy0 (_tmp3_);
	__vala_GdkRGBA_free0 (self->priv->_new_color);
	self->priv->_new_color = _tmp4_;
	return self;
}

UndoConnectionColor*
undo_connection_color_new (Connection* c,
                           GdkRGBA* old_color)
{
	return undo_connection_color_construct (TYPE_UNDO_CONNECTION_COLOR, c, old_color);
}

static void
undo_connection_color_real_undo (UndoItem* base,
                                 DrawArea* da)
{
	UndoConnectionColor * self;
	Connection* _tmp0_;
	GdkRGBA* _tmp1_;
	self = (UndoConnectionColor*) base;
	g_return_if_fail (da != NULL);
	_tmp0_ = self->priv->_conn;
	_tmp1_ = self->priv->_old_color;
	connection_set_color (_tmp0_, _tmp1_);
	gtk_widget_queue_draw ((GtkWidget*) da);
	g_signal_emit_by_name (da, "current-changed", da);
	draw_area_auto_save (da);
}

static void
undo_connection_color_real_redo (UndoItem* base,
                                 DrawArea* da)
{
	UndoConnectionColor * self;
	Connection* _tmp0_;
	GdkRGBA* _tmp1_;
	self = (UndoConnectionColor*) base;
	g_return_if_fail (da != NULL);
	_tmp0_ = self->priv->_conn;
	_tmp1_ = self->priv->_new_color;
	connection_set_color (_tmp0_, _tmp1_);
	gtk_widget_queue_draw ((GtkWidget*) da);
	g_signal_emit_by_name (da, "current-changed", da);
	draw_area_auto_save (da);
}

static void
undo_connection_color_class_init (UndoConnectionColorClass * klass,
                                  gpointer klass_data)
{
	undo_connection_color_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &UndoConnectionColor_private_offset);
	((UndoItemClass *) klass)->undo = (void (*) (UndoItem*, DrawArea*)) undo_connection_color_real_undo;
	((UndoItemClass *) klass)->redo = (void (*) (UndoItem*, DrawArea*)) undo_connection_color_real_redo;
	G_OBJECT_CLASS (klass)->finalize = undo_connection_color_finalize;
}

static void
undo_connection_color_instance_init (UndoConnectionColor * self,
                                     gpointer klass)
{
	self->priv = undo_connection_color_get_instance_private (self);
}

static void
undo_connection_color_finalize (GObject * obj)
{
	UndoConnectionColor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_UNDO_CONNECTION_COLOR, UndoConnectionColor);
	_g_object_unref0 (self->priv->_conn);
	__vala_GdkRGBA_free0 (self->priv->_old_color);
	__vala_GdkRGBA_free0 (self->priv->_new_color);
	G_OBJECT_CLASS (undo_connection_color_parent_class)->finalize (obj);
}

static GType
undo_connection_color_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UndoConnectionColorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) undo_connection_color_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UndoConnectionColor), 0, (GInstanceInitFunc) undo_connection_color_instance_init, NULL };
	GType undo_connection_color_type_id;
	undo_connection_color_type_id = g_type_register_static (TYPE_UNDO_ITEM, "UndoConnectionColor", &g_define_type_info, 0);
	UndoConnectionColor_private_offset = g_type_add_instance_private (undo_connection_color_type_id, sizeof (UndoConnectionColorPrivate));
	return undo_connection_color_type_id;
}

GType
undo_connection_color_get_type (void)
{
	static volatile gsize undo_connection_color_type_id__once = 0;
	if (g_once_init_enter (&undo_connection_color_type_id__once)) {
		GType undo_connection_color_type_id;
		undo_connection_color_type_id = undo_connection_color_get_type_once ();
		g_once_init_leave (&undo_connection_color_type_id__once, undo_connection_color_type_id);
	}
	return undo_connection_color_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

